// Soluzione Prova di Laboratorio 31/05/10

#include <stdio.h>
#include <stdlib.h>

typedef struct _Nodo{
 int cifra;
 struct _Nodo *succ;
} Nodo;

typedef Nodo* Lista;


// Legge la sequenza di cifre, crea la lista contenente l'intero e ne restituisce la lunghezza
int ReadInt(Lista *in){

 int cifra=0;
 int len = 0;
 Nodo *n=NULL;
 Nodo **tmp = in;

 while (1) {
   scanf("%d", &cifra);
  
   if (cifra != -1) {
       n = malloc(sizeof(Nodo));
       *tmp = n;   
       n->cifra = cifra;
       n->succ = NULL;    
       tmp = &(n->succ);
       len++;
   } else
       break;    
 } 

 return len;	  
}

// Stampa gli interi in una lista saltando eventuali zeri iniziali
void PrintInt(Lista i){
	while (i->cifra == 0 && i != NULL) i=i->succ;
	for (;i != NULL; i=i->succ)
	    printf("%d ",i->cifra);
        printf("-1\n");
}


// Calcola p = p - m e restituisce l'eventuale riporto, 
// assumendo che le due liste abbiano uguale lunghezza.
// Semplice implmentazione ricorsiva lineare in spazio e tempo

int Diff(Lista p, Lista m){

int carry = 0;
int ncarry;

if (p != NULL) {
	
	ncarry = Diff(p->succ, m->succ); // calcola ricorsivamente la differenza tra le code
       
        if (p->cifra < m->cifra + ncarry) // abbiamo riporto in questo caso
           carry = 1; 

        p->cifra = (p->cifra + 10 - m->cifra - ncarry) % 10; // calcola la cifra corrente

}

return carry;
}


int main(){

Lista p,m;
int lengthp, lengthm;
Nodo *zero;

lengthp= ReadInt(&p);
lengthm= ReadInt(&m);

// aggiunge zeri iniziali ad m per renderlo lungo quanto p
for (;lengthm < lengthp; lengthm++){
 	zero= malloc(sizeof(Nodo));
	zero->cifra = 0;
 	zero->succ = m;
 	m= zero;
}
 
Diff(p,m);

PrintInt(p);

return 0;
}
